//___________________________________________________________________
// P REISS    Traces.h       donnees de Viseur
//  _Jat[8]	attributs:
//         0 _ couleur		    0 a 0xff	   defaut = 2
//         1 _ type de ligne	    1 = continu	   defaut = 1
//                                  2 = pointille
//                                  3 = tirete
//                                  4 = tirete large
//         2 _ sous-intensite 	    0 = normal	   defaut = 0
//                                  1 = sous-intensifie
// 				        (detectabilite CATIA)
//         3 _ taille de texte	    1 a 4	   defaut = 3
//         4 _ orientation de texte		   defaut = 0
//                                  0 = gauche a droite
//                                  3 = bas en haut
//         5 _ epaisseur de trait   1 a 8          defaut = 1
//         7 _ inversion du sens de Y
//  _AffCnt      nombre de points affiches; extension pour dragging
//  _PremAff     rang de 1er point affiche dans (x,y)
//  _Iou         offsets d' allocations (2), (2eme colonne de 2), (3)
//  _Ku          2 (debut); 1 (retrace par Vicads); 3 (retrace pur)
//  _Cev         centre (croisement des axes) vrai
//  _Mu0         centre sur ecran en espace proportionnel (int)
//  _Mu1         centre sur ecran en espace logarithmique (int)
//  _Gr          facteur d' echelle
//  _Gdv         pas de graduation vrai
//  _Gde         pas de graduation sur ecran
//  _CarCnt      nombre total de caracteres
//  _DeciCnt     nombre de decimales apres le point
//  _VueTaille   taille de vue (ecran)
//  _Xa,_Xb,_Ya,_Yb	cadre vrai
//  _Aje         cadre ecran = (x gauche, x droit, y bas, y haut)
//               en unites raster = ( 0., 4095., 0., 3855. )
//  _Vi          viewport de vue graphique
//  _Wi          window   de vue graphique
//  _CouCnt      compteur de courbes
//  _Filter      critere de choix des observations
//  _Col         indice de couleur courante
//  _Ix          _Ix(ecran) = (xvrai-_Xa) * gx + _IxMin(ecran)
//  _Pu          buffer de points temporaires
//  _Iz          1 si point de zoom en cours
//  _IsNoTrans   1 si pas de translation en cours
//  _IsKino      1 si animation en cours
//  _Avance      delta en abscisse pour animation
//  _Vitesse     indice sur [-5, +5], protection
//  _KiRatio     dilatation de fenetre d' animation
//  _Slice       seuils de continuite de courbes en temps
//                 (1ere courbe, autres courbes)
//  _Chur        caractere courant
//  _IsMaj       caractere majuscule
//  _IsResize    resize en cours
//  _RatioXY     hauteur ecran / largeur ecran en float
//  _OnlyOne     une seule pression conservee
//  _GraduTxt    texte de graduation
//  _Limit       tableau de rangs dans Xpt, Ypt
//               observateur N sur [_Limit[N-1], _Limit[N]-1]
//	variables exclusivement dans Vicair.cpp:
//  _ToApprox, _Fa, _Fe, _Fi, _Arr

#include "GraTypes.h"
#define  PIC     4095.

extern "C" class Set
  {
  public:
    void   Viaxor ( double*, double*, float* ), Vicair (),
           Vider  (), Vigies (), Vijour (), Vipor ( double* ),
           Viracs ( int*, int*, float* ), ComputeImage (),
           Vicads (), Visdor (), Vianal ( char*, char* ),
           Vinits ( int, int, int, int&, int& );
    int    Vibour (), Kicads ();

    double _Xa, _Xb, _Ya, _Yb,	// au debut pour mapping sur Sot
           _Wi[2][2], _VueTaille[2], _ToApprox[2], _Pu[2][3],
           _Avance, _Aje[2][2], _SavePt[2][2], _Fa, _Fe, _Fi, _Arr,
           _Gde[2], _Cev[2], _Gdv[2], _Gr[2], _Slice[2], _KiRatio;
    silla  _Iou[3];
    float  _RatioXY;
    int    _Vi[2][2], _Mu[2][2], _Ix[2], _CarCnt[2], _DeciCnt[2],
           _AffCnt, _CouCnt, _Col, _Ku, _PremAff, _TotCnt, _Jat[8],
           _Iz, _Hac, _Lac, _Limit[1024+1], _IsKino, _Delay, _Speed,
           _Vitesse;
    char   _IsNoTrans, _GraduTxt[17], _Chur, _FiCours[25], _IsMaj,
           _IsResize, _OnlyOne, _Filter[8];
  };

struct Sot			// pour optimiser Vigies
  {
  double _Ax, _Bx, _Ay, _By;
  };

extern "C" class Sat		// display list pour Open GL
  {
  public:
    silla  _Iall;		// offset + 1
    int    _Ir;			// nombre total dans la structure
    int    _IsGi;
  };
//___________________________________________________________________
