//________________________________________________________________________
// P REISS	 Viaxor
// partie graphique = courbes + axes gradues + trame tenue
// entrees :
//    double Xpt[n]	: points a tracer
//    double Ypt[n]
// tableau de travail interne :
//    float Ax[3][2]	: memes points, recadres ici

#include "stdio.h"
#include "math.h"
#include "Pro.h"
#include "Traces.h"
static   int De = 2, Qu = 4;

void Set::Viaxor ( double *Xpt, double *Ypt, float *Fax )
  {
  double Dax[3][2], Dog, Dou;
  float  (*Ax)[3][2] = (float (*)[3][2]) Fax, Gone[4][2];
  int    Idx, Jdx, Adx, Gdx, Pdx, Cdx, Ni[2], Mi[2], Li[2],
         Len, Na, Nc, Nv, Deb, Fin, Color;
  char   Cm[9];
  //______________________________________________________________________
  // 1 _ initialisations graphiques

  _Jat[0] = 2;				// code visu standard
  _Jat[1] = 1;
  _Jat[2] = 0;
  _Jat[3] = 4;
  _Jat[5] = 1;
  _Jat[7] = 1;				// inversion du sens de Y
  //______________________________________________________________________
  // 4 _ trace des axes et de la trame tenue

  for ( Idx=0; Idx<2; Idx++ )           // boucle axe x, puis axe y
    {					// pour trame
    // numero Ni+1 de la graduation correspondant a l' autre axe
    // echelle proportionnelle

    Ni[Idx]  = _Aje[Idx][0];
    Li[Idx]  = _Aje[Idx][1];
    Mi[Idx]  = Ni[Idx];
    Ni[Idx] += Ni[Idx] - Li[Idx];	// 3x plus de graduations
    Li[Idx] += Li[Idx] - Mi[Idx];	// pour dragging
    Ni[Idx]  = ( _Mu[0][Idx] - Ni[Idx] - 1 ) / _Gde[Idx];
    Li[Idx]  = Ni[Idx] + ( Li[Idx] - _Mu[0][Idx] - 1 ) / _Gde[Idx];
    Dou      = _Cev[Idx] - Ni[Idx] * _Gdv[Idx];
    Adx      = 1 - Idx;

    for ( Gdx=0; Gdx<=Li[Idx]; Gdx++ )	// boucle sur la trame
      {
      //__________________________________________________________________
      // 2 _ calcul de la position de la droite de trame
      //     (horizontale ou verticale)

      Dax[0][Idx] = _Mu[0][Idx] + ( Gdx - Ni[Idx] ) * _Gde[Idx];
      Dax[0][Adx] = _Aje[Adx][0] + _Aje[Adx][0] - _Aje[Adx][1];
      Dax[1][Idx] = Dax[0][Idx];	// point Ax[2] en unites raster
      Dax[1][Adx] = _Aje[Adx][1] + _Aje[Adx][1] - _Aje[Adx][0];

      for ( Na=0; Na<2; Na++ )
        for ( Jdx=0; Jdx<2; Jdx++ )
          (*Ax)[Na][Jdx] = Dax[Na][Jdx];

      if ( _Jat[7] )
        for ( Na=0; Na<2; Na++ )
          (*Ax)[Na][1] = _Aje[1][0] + _Aje[1][1] - Dax[Na][1];
      //__________________________________________________________________
      // 3 _ axes et trame sous-intensifiee

      _Jat[2] = 1;			// sous-intensifie
      if ( !Idx )
        Dog = double ( int (Dou + .1) );// Dou relativement precis

      if ( Gdx == Ni[Idx]   &&   Idx )
        {
        _Jat[0] = 35;			// axe gris clair
        _Jat[2] = 0;
        }

      if ( Idx   ||   fabs (Dou - Dog) <= 1.e-4 )
        Visupl ( (float*) (*Ax), &De, _Jat );

      Dou += _Gdv[Idx];
      }					// fin for Gdx
    }					// fin for Idx
  //______________________________________________________________________
  // 5 _ trace d' un repere de milieu d' axe x (temps)

  if ( _Jat[7]   &&   !_IsKino )
    {
    _Jat[0]     = 11;			// bleu sombre
    _Jat[2]     = 0;
    (*Ax)[0][0] = ( _Aje[0][0] + _Aje[0][1] ) * .5;
    (*Ax)[1][0] = (*Ax)[0][0];
    (*Ax)[0][1] = _Aje[1][0];
    (*Ax)[1][1] = _Aje[1][0] + ( _Aje[1][1] - _Aje[1][0] ) * .1;
    Visupl ( (float*) (*Ax), &De, _Jat );
    }
  //______________________________________________________________________
  // 9 _ trace des graduations

  for ( Idx=0; Idx<2; Idx++ )           // boucle axe x, puis axe y
    {
    // numero Ni+1 de la graduation correspondant a l' autre axe
    // echelle proportionnelle

    Dou = _Cev[Idx] - Ni[Idx] * _Gdv[Idx];
    Adx = 1 - Idx;
    Nv  = _Aje[Adx][0] + 80.;		// graduations en lisiere

    for ( Gdx=0; Gdx<=Li[Idx]; Gdx++ )	// boucle sur les graduations
      {
      //__________________________________________________________________
      // 6 _ calcul du point d' ancrage Ax2 de la graduation

      Dax[2][Idx] = _Mu[0][Idx] + ( Gdx - Ni[Idx] ) * _Gde[Idx];
      Dax[2][Adx] = Nv;                 // en unites raster

      for ( Jdx=0; Jdx<2; Jdx++ )
        (*Ax)[2][Jdx] = Dax[2][Jdx];

      if ( _Jat[7] )
        {
        (*Ax)[2][1] = _Aje[1][0] + _Aje[1][1] - Dax[2][1];
        if ( !Idx )
          (*Ax)[2][1] -= 25.f * _CarCnt[Idx] * _RatioXY;
        }
      //__________________________________________________________________
      // 7 _ texte de la graduation

      // conversion du double Dou en chaine de 16 octets au format f,
      // cadre a gauche, avec _DeciCnt decimales apres le point,
      // ou sans point si _DeciCnt nul;   17e octet = '\0'

      Len = _CarCnt[Idx];
      sprintf ( _GraduTxt, "%-16.*f", _DeciCnt[Idx], Dou );

      // axe X gradue en dates (_CarTxt = 10)

      if ( !Idx )
        {
        Nc  = Dou + .1;			// Dou relativement precis
        Dog = double (Nc);
        Visdar ( &Nc, _GraduTxt );	// date
        }

      if ( Idx   ||   fabs (Dou - Dog) <= 1.e-4 )
        {
        // 8 _ affichage de la graduation:   texte = _GraduTxt[_CarCnt]
        //     toujours peinte APRES la trame

        _Jat[0] = 2;			// standard
        _Jat[2] = 0;
        _Jat[4] = 1 - Idx;
        if ( _IsKino > 0 )
          _Jat[0] = 10;			// jaune si cinema
        Visutx ( &(*Ax)[2][0], &Len, _GraduTxt, _Jat, _RatioXY );
        }

      Dou += _Gdv[Idx];
      }					// fin for Gdx
    }					// fin for Idx
  // fin _ 9 _

  Color = _Col;

  for ( Cdx=1; Cdx<=_CouCnt; Cdx++ )	// boucle sur les courbes
    {
    //____________________________________________________________________
    // 10 _ incrementation automatique de la couleur [5, 32+5[

    Color   = (Color-4) % 32 + 5;	// gestion de 32 couleurs
    _Jat[0] = Color;			// standard + couleur
    _Jat[2] = 0;

    //____________________________________________________________________
    // 11 _ affichage de la courbe en tant que polyline
    //      _Ix(ecran) = ( xvrai - _Xa ) * gx + _IxMin(ecran)

    Deb = _Limit[Cdx-1];
    Fin = _Limit[Cdx];

    if ( Cdx == 1 )
      {
      Deb = _PremAff;
      Fin = Deb + _AffCnt;
      }

    for ( Pdx=Deb; Pdx<Fin; Pdx++ )
      {
      (*Ax)[0][0] = ( Xpt[Pdx] - _Cev[0] ) * _Gr[0] + _Mu[0][0];
      Dax  [0][1] = ( Ypt[Pdx] - _Cev[1] ) * _Gr[1] + _Mu[0][1];
      Dou         = fabs ( Xpt[Pdx] - Xpt[Pdx-1] );

      if ( _Jat[7] )
        (*Ax)[0][1] = _Aje[1][0] + _Aje[1][1] - Dax[0][1];
      else
        (*Ax)[0][1] = Dax[0][1];

      if ( Pdx > Deb   &&   ( (Cdx == 1   &&   Dou < _Slice[0])   ||
                              (Cdx >  1   &&   Dou < _Slice[1]) ) )
        Visupl ( (float*) (*Ax), &De, _Jat );
      else
        {
        // interrompre la courbe continue si plus d' une heure entre
        // 2 points consecutifs (1 h = 0.04 jour)
        // interruption de courbe plus rare pour observateur isole
        //   (cas Cdx>1)

        Gone[0][0] = (*Ax)[0][0] + 8.;	// polymarker
        Gone[0][1] = (*Ax)[0][1];	//   carre, pose
					//   sur la pointe
        Gone[1][0] = (*Ax)[0][0];
        Gone[1][1] = (*Ax)[0][1] + 8.;

        Gone[2][0] = (*Ax)[0][0] - 8.;
        Gone[2][1] = (*Ax)[0][1];

        Gone[3][0] = (*Ax)[0][0];
        Gone[3][1] = (*Ax)[0][1] - 8.;

        Visupg ( (float*) Gone, &Qu, _Jat );
        }

      (*Ax)[1][0] = (*Ax)[0][0];
      (*Ax)[1][1] = (*Ax)[0][1];
      }
    //____________________________________________________________________
    // 12 _ numero de courbe sur dernier point, meme couleur

    if ( Cdx == 1 )
      {
      Pdx         = _Limit[1] - 1;
      (*Ax)[1][0] = ( Xpt[Pdx] - _Cev[0] ) * _Gr[0] + _Mu[0][0];
      Dou         = ( Ypt[Pdx] - _Cev[1] ) * _Gr[1] + _Mu[0][1];

      if ( _Jat[7] )
        (*Ax)[1][1] = _Aje[1][0] + _Aje[1][1] - Dou;
      else
        (*Ax)[1][1] = Dou;
      }

    (*Ax)[1][0] += 10.;			// taille 3 des textes => (3-1)*16
    _Jat[4]      = 0;
    sprintf ( Cm, "%4d", Cdx );
    Visutx  ( &(*Ax)[1][0], &Qu, Cm, _Jat, _RatioXY );
    }					// fin for Cdx
  }
//________________________________________________________________________
