//__________________________________________________________________________
// P REISS   Vibour
// f12.5 + 1 blanc + f5.2
// taille de Eu >= 155 (cf NovaDelAavso)
// N courbes a partir de "Observer1 a N":
// 1ere      = tous observateurs
// suivantes = 1 seul observateur (courbe englobee dans la 1ere)
// format AAVSO avec delimiteur "comma", space ou tab:
//   2456518.46209,<8.0,,,Vis.,VNL,,8.0,8.3,12506xc,commentaires,...

#include "stdio.h"
#include "string.h"
#include "ctype.h"			// pour toupper
#include "Pro.h"
#include "Traces.h"
#define  HAC 585			// 1024
#define  LAC 804			// 981
extern   double Dynar[1];
//__________________________________________________________________________
// lecture des donnees AAVSO

int Set::Vibour ()
  {
  double Delta;
  silla  Jdx64;
  int    Idx, Jdx, Ny, Na, Type = 2, Lon, Lun, Lof, Ka, Rejet;
  char   Eu[256], *Cur, Filtre[3][7], Sep[] = " ,\t";
  static int Un = 1, Tr = 3, Fu = 5;
  //________________________________________________________________________
  // JJ 2456526. = 21/08/2013 a 12h TU (14h heure d' ete)
  // fichier ObserverNNN: X = JJ, lu sans le "24" des 2 premiers caracteres

  Delta      = 2400000. - 2456526. + 12./24. +
               double ( Visdas ( "21/08/2013" ) );
  _Avance    = 0.002;
  _Slice[0]  = .04;			// 1 heure
  _Slice[1]  = 3.;			// 3 jours
  _IsMaj     = 0;			// minuscule par defaut
  _IsResize  = 0;			// pas de resize en cours
  _OnlyOne   = 0;			// une seule pression
  _CouCnt    = 0;
  _Limit[0]  = 0;
  _Iz        = 0;
  _IsNoTrans = '\1';
  _IsKino    = 0;
  _Delay     = -1;
  _Speed     = 3;
  _Vitesse   = 0;
  _KiRatio   = -1.;			// non initialise
  _Col       = 4;
  Ny         = 0;
  Lon        = (int) strlen ( _FiCours );
  Lof        = (int) strlen ( _Filter );

  if ( Lof )				// 3 filtres
    for ( Idx=0; Idx<3; Idx++ )
      {
      strcpy ( Filtre[Idx]+1, _Filter );
      Filtre[Idx][0]     = Sep[Idx];
      Filtre[Idx][Lof+1] = Sep[Idx];
      Filtre[Idx][Lof+2] = '\0';
      }

  while ( 1 )
    {
    //______________________________________________________________________
    // lecture d' un fichier pour une courbe

    _CouCnt++;
    if ( _CouCnt > 1024 )   break;	// pas trop de courbes

    if ( _CouCnt < 10 )
      sprintf ( _FiCours + Lon, "%1d\0", _CouCnt );
    else if ( _CouCnt < 100 )
      sprintf ( _FiCours + Lon, "%2d\0", _CouCnt );
    else if ( _CouCnt < 1000 )
      sprintf ( _FiCours + Lon, "%3d\0", _CouCnt );
    else
      sprintf ( _FiCours + Lon, "%4d\0", _CouCnt );

    Lun = (int) strlen ( _FiCours );
    Na  = Praxes ( _FiCours, &Lun, &Un );
					// ouvre <StarName>_NNN
    if ( Na )   break;                  // fichier inexistant

    while ( 1 )
      {
      Praxes ( Eu, &Na, &Tr );		// lit Na caracteres
      if ( !Na )   break;
      if ( *Eu == '/'   ||   Eu[3] == 'J' )   continue;
                                        // 1ere ligne "JD"...
      if ( Lof   &&   _CouCnt == 1 )	// filtrage
        {
        Rejet = -1;
        Jdx   = 0;
        Ka    = (int) strlen ( Eu );
        for ( Idx=2; Idx<Ka; Idx++ )
          {
          if ( strchr ( Sep, Eu[Idx] ) )   Jdx++;
          if ( Jdx == 3 )                  break;
          }
        for ( Jdx=0; Jdx<2; Jdx++ )	// filtre en Eu+Idx+1
          Rejet += strstr ( Eu+Idx+1, Filtre[Jdx] ) == 0;
        if ( Rejet )   continue;
        }

      // decodage valable sur tous formats

      Jdx     = Ny + 5;
      _Iou[0] = Malt ( &Jdx, &Type, &_Iou[1] );
      Cur     = strtok ( Eu + 2, Sep );
      sscanf ( Cur, "%lf", Dynar+_Iou[0]+Ny );
      Cur     = strtok ( 0, Sep );
      if ( *Cur == '<' )   Cur++;	// magnitude
      sscanf ( Cur, "%lf", Dynar+_Iou[1]+Ny );
      Dynar[_Iou[0]+Ny] += Delta;	// jour julien

      //*** decodage sur mon format fixe:
      // sscanf ( Eu + 2, "%11lf", Dynar+_Iou[0]+Ny );
      // Dynar[_Iou[0]+Ny] += Delta;
      // if ( !Eu[18] )
      //   sscanf ( Eu + 14, "%4lf", Dynar+_Iou[1]+Ny );
      // else
      //   sscanf ( Eu + 14, "%5lf", Dynar+_Iou[1]+Ny );
      //***

      Ny++;
      }					// fin while 1
    Praxes ( _FiCours, &Un, &Fu );	// ferme <StarName>_NNN
    _Limit[_CouCnt] = Ny;		// nombre total de points
    //______________________________________________________________________
    }

  _CouCnt--;
  if ( !_CouCnt )   return 0;		// protection

  // Dynar[ _Iou[2] ] = tableau r*4 ax(3,max(Ny,3))

  Idx      = Ny + Ny + 6;
  _Iou[2]  = Malt ( &Idx, &Tr, &Jdx64 );

  // affichage de courbes a cadrer en Ny points:
  // Dynar [ _Iou[0] ] en echelle proportionnelle (X)
  // Dynar [ _Iou[1] ] en echelle proportionnelle (Y)

  _TotCnt  = _Limit[1];			// nombre de points de 1ere courbe

  // nombre de points effectivement traces
  _AffCnt  = _TotCnt;

  // position _PremAff dans (Dynar[_Iou0], Dynar[_Iou1]) du 1er point trace
  _PremAff = 0;
  //________________________________________________________________________
  // renverser Dynar[_Iou[0] et _Iou[1]] sur [0, _Limit[1][
  // pour rendre les X croissants, s' ils ne le sont pas

  Na = _Limit[1] >> 1;

  if ( Dynar[_Iou[0]] > Dynar[_Iou[0]+_Limit[1]-1] )
    for ( Jdx=0; Jdx<2; Jdx++ )
      {
      Jdx64 = _Iou[Jdx] + _Limit[1] - 1;
      for ( Idx=0; Idx<Na; Idx++ )
        {
        Delta                = Dynar[_Iou[Jdx]+Idx];
        Dynar[_Iou[Jdx]+Idx] = Dynar[Jdx64];
        Dynar[Jdx64--]       = Delta;
        }
      }
  return 1;
  }
//__________________________________________________________________________
// analyse des entrees du programme

void Set::Vianal ( char* Input, char* Affiche )
  {
  static char StringMid[] = " _ AAVSO data processed by PREB ",
              StringEnd[] = "[Pierre REISS] _ X axis in UniversalTime",
              Visual[]    = "Vis.", Filters[32][7] = {
              "Visual", "U", "B", "V", "R", "I", "J", "H", "K", "TG", "TB",
              "TR", "CV", "CR", "Z", "SZ", "SU", "SG", "SR", "SI", "STU",
              "STV", "STB", "STY", "STHBW", "STHBN", "MA", "MB", "MI", "HA",
              "HAC", "O" };
  char        *Cor = 0, *Cur, Buf[8], Car;
  int         Success = 1, Len, Code, Idx, Fdx = 0;

  _Hac        = HAC;
  _Lac        = LAC;
  _Filter[0]  = '\0';		// pas de filtre
  _FiCours[0] = '\0';

  if ( strlen ( Input ) )
    {				// parametres apres "Intraday "
    Cor    = strtok ( Input, " ," );
    Buf[6] = '\0';
    strncpy ( Buf, Cor, 6 );
    for ( Idx=0; Idx<6; Idx++ )	// Buf en majuscules
      Buf[Idx] = toupper ( Buf[Idx] );

    if ( !strncmp ( Buf, "FILTER", 6 ) )
      {				// analyse de filtre
      if ( strlen ( Cor ) == 6 )   Cor  = strtok ( 0, " ," );
      else                         Cor += 6;

      if ( !Cor   ||   *Cor != '=' )
        Success = 0;
      else
        {
        if ( strlen ( Cor ) == 1 )   Cor = strtok ( 0, " ," );
        else                         Cor++;

        if ( !Cor )   Success = 0;
        else
          {
          for ( Idx=0; Idx<6; Idx++ )
            {
            Car = Cor[Idx];
            if ( Car == ' '   ||   !Car )   break;
            _Filter[Idx] = toupper ( Car );
            }
          _Filter[Idx] = '\0';	// fin de chaine

          if ( !strncmp ( _Filter, "VIS", 3 ) )
            strcpy ( _Filter, Visual );
          else
            {
            for ( Code=0, Fdx=1; Fdx<32; Fdx++ )
              if ( Code |= (strcmp ( _Filter, Filters[Fdx] ) == 0) )
                break;
            if ( !Code )   Success = -1;
            }			// filtre inconnu

          Cor = strtok ( 0, " ," );
          }
        }
      }

    if ( Cor   &&   Success > 0 )
      {				// analyse de nom d' etoile
      Cur = strchr ( Cor, ' ' );
      if ( !Cur )
        Len = (int) strlen ( Cor );
      else
        Len = (int) ( Cur - Cor );

      strncpy ( Affiche,  Cor, (size_t) Len );
      strncpy ( _FiCours, Cor, (size_t) Len );
      Affiche[Len]    = '\0';
      _FiCours[Len]   = '_';
      _FiCours[Len+1] = '\0';
      }
    }

  if ( Success > 0   &&   !Cor )
    {				// NovaDel = etoile par defaut
    strcpy ( _FiCours, Affiche );
    strcat ( _FiCours, "_" );
    }

  Code = Vibour ();		// preparation des donnees a afficher
  if ( Success > 0 )
    {
    if ( Code )
      {
      strcat ( Affiche, StringMid );
      strcat ( Affiche, StringEnd );
      if ( *_Filter )
        {
        strcat ( Affiche, " _ Filter = " );

        if ( Fdx )
          strcat ( Affiche, _Filter );
        else
          strcat ( Affiche, Filters[0] );
        }
      }
    else			// protection
      strcpy ( Affiche,
               "Please, create at least the file <StarName>_1 !" );
    }
  else if ( Success < 0 )
    strcpy ( Affiche,
             "Please, give a known filter, \"Filter=B\" for instance !" );
  else
    strcpy ( Affiche,
             "Please, give a filter, \"Filter=Visual\" for instance !" );
  }
//__________________________________________________________________________
// visu initiale

void Set::Vinits ( int Init, int Lar, int Hau, int &IniLar, int &IniHau )
  {
  if ( Init )
    {
    IniLar    = Lar;
    IniHau    = Hau;
    _RatioXY  = float ( Lar ) / float ( Hau );
    _IsResize = 0;
    }
  else
    _IsResize = 1;

  _Ku         = 2;
  _AffCnt     = _TotCnt;
  _Vi[0][0]   = 0;
  _Vi[0][1]   = 0;
  _Vi[1][0]   = Lar;
  _Vi[1][1]   = Hau;
  _Aje[0][0]  = 0.;
  _Aje[0][1]  = PIC * Lar / IniLar;
  _Aje[1][0]  = 0.;
  _Aje[1][1]  = PIC * Hau / IniHau;
  }
//__________________________________________________________________________
