//_____________________________________________________________________________
// P REISS	  Vicair	cadrage automatique
//   _ recalage de l' origine sur un point de la fenetre
//     d' affichage, a coordonnees rondes
//   _ trace d' axes et 20 graduations rondes

#include "math.h"
#include "Pro.h"
#include "Traces.h"

void Set::Vicair ()
  {
  // equivalence complexe entre C et _Xa

  double (*C)[2][2] = (double (*)[2][2]) &_Xa, Val;
  static int Un = 1, De = 2;
  int    Idx, Jdx, Kdx, Ky, Ka, Ki;
  char   Logi, IsBreak;

  for ( Idx=0; Idx<2; Idx++ )           // traitement en x, puis en y
    {
    //_________________________________________________________________________
    // 5 _ reglage du cadre C[2][2]
    // protection simultanee en absolu et en relatif
    // pas d' englobement force de 0.

    if ( (*C)[Idx][0] == (*C)[Idx][1] )
      (*C)[Idx][1] = (*C)[Idx][0] + 1.e-6 +
                     fabs ( (*C)[Idx][0] ) * 1.e-5;
    Kdx = fabs ( (*C)[Idx][0] ) > fabs ( (*C)[Idx][1] );
    Ky  = 1 - Kdx;
    //_________________________________________________________________________
    // 6 _ choix des axes
    // centre (croisement des axes) _Cev vrai, _Mu sur ecran
    // nombre _DeciCnt de chiffres significatifs

    _Cev[Idx]     = 0.;
    _DeciCnt[Idx] = 2;
    Logi          = (*C)[Idx][0] * (*C)[Idx][1] < 0.;
    if ( !Logi )
      {
      for ( Jdx=0; Jdx<2; Jdx++ )
        _ToApprox[Jdx] = fabs ( (*C)[Idx][Jdx] );
      _Fi = _ToApprox[1] * .05;
      if ( _ToApprox[0] < _Fi )
        _ToApprox[0] = _Fi;
      _Fi     = 0.f;
      IsBreak = 0;

      while ( 1 )
        {
        _Arr = _ToApprox[Kdx] + ( _ToApprox[Ky] - _ToApprox[Kdx] ) * .9;

        for ( Jdx=2; Jdx>=0; Jdx-- )
          {
          _Fa       = Arrons ( &_ToApprox[Kdx], &Val, &Jdx );
          _Fe       = _Fa / Val;	// alors, _Fe approche abs ( e[Kdx] )
          _Cev[Idx] = _Fe;
          if ( !Jdx   &&   fabs ( _ToApprox[Kdx] ) != _Fe )
            _Cev[Idx] = ( _Fa + 1. ) / Val;

          if ( _Cev[Idx] <= _Arr )
            {
            IsBreak = 1;
            break;
            }
          }
        if ( IsBreak )   break;
        _Fi += _Fe;
        _DeciCnt[Idx] ++;
        for ( Jdx=0; Jdx<2; Jdx++ )   _ToApprox[Jdx] -= _Fe;
        }

      Val       = fabs ( _Cev[Idx] + _Fi );
      _Cev[Idx] = (*C)[Idx][0]>=0. ? Val : -Val;
      }
    //_________________________________________________________________________
    // 7 _ positionnement des axes dans l' espace ecran

    _Fi = _Aje[Idx][1] - _Aje[Idx][0];
    _Fe = (*C)[Idx][1] - (*C)[Idx][0];
    Val = _Fi / _Fe;

    // -5. '%' 3. = -2.   !!!
    // _Mu0, _Gde en espace proportionnel

    _Mu[0][Idx] = ( _Cev[Idx] - (*C)[Idx][0] ) * Val + _Aje[Idx][0];
    //_________________________________________________________________________
    // 8 _ facteur d' echelle _Gr, pas de graduation: _Gdv vrai, _Gde sur ecran

    _Gr[Idx]  = Val;			// pas d' arrondi avec Arrons(&3)
    Val       = Arrons ( &_Fe, &_Fi, &Un );
    _Arr      = Val<4. ? Val : 4.;
    _Gdv[Idx] = _Arr / ( 20. * _Fi );
    _Gde[Idx] = _Gdv[Idx] * _Gr[Idx] * 1.0001;
    //_________________________________________________________________________
    // 9 _ calcul de l' encombrement (_CarCnt,_DeciCnt)
    //     du texte d' une graduation
    //     fe = nombre le + encombrant

    _Arr = Arrons ( &(*C)[Idx][Kdx], &_Fa, &De );
    _Fe  = (*C)[Idx][Ky] + (*C)[Idx][Ky] - (*C)[Idx][Kdx];
    _Arr = Arrons ( &_Fe, &_Fi, &De );

    // Ka pour signe - ; attention au zero devant le point :
    //                   donne la condition qui suit le 2eme '||'

    Ka = _Fe < 0.   ||   Logi   &&   ( _Fi == _Fa   ||
         fabs ( (*C)[Idx][Kdx] ) < 1.   &&   fabs ( _Fe ) >= 1. );
	  
    // nombre de chiffres precedant le point decimal

    Ki = -log10 ( _Fi ) * 1.01;

    // _DeciCnt = nombre de decimales apres le point
    // _CarCnt  = nombre total de caracteres

    _DeciCnt[Idx] -= Ki;
    _DeciCnt[Idx]  = _DeciCnt[Idx]>0 ? _DeciCnt[Idx] : 0;
    if ( _Gdv[Idx] < pow ( 10., -_DeciCnt[Idx] ) )   _DeciCnt[Idx] ++;

    // point decimal dans tous les cas, au lieu de _DeciCnt[Idx] > 0

    _CarCnt[Idx] = ( Ki>1 ? Ki : 1 ) + Ka + _DeciCnt[Idx] + 1;
    }                                   // fin for Idx
  _CarCnt[0] = 10;			// date en abscisse
  }                                     // fin Vicair
//_____________________________________________________________________________
