//______________________________________________________________________
// P REISS   Viracs

#include "math.h"
#include "string.h"
#include "Pro.h"
#include "Traces.h"
extern double Dynar[1];
static double Zo, Pont[2][2] = { 10., 60., 0.00001, 0.0001 };
static int    Un = 1, De = 2;

//______________________________________________________________________
// change view mapping de vue graphique de sortie

void Set::Vijour ()
  {
  Gpvmp2 ( &Un, &De, (double*) _Wi, (int*) _Vi );
  Vinval ();
  }
//______________________________________________________________________
// calcul d' image

void Set::ComputeImage ()
  {
  Vigies ();				// peinture
  Vijour ();				// affichage
  }
//______________________________________________________________________
// recadrage

void Set::Vicads ()
  {
  for ( int Pdx=0; Pdx<2; Pdx++ )
    for ( int Idx=0; Idx<2; Idx++ )
      _Pu[Pdx][Idx] = ( _Wi[Idx][Pdx] - _Mu[0][Idx] )
                      / _Gr[Idx] + _Cev[Idx];
  _Ku = 1;
  ComputeImage ();
  }
//______________________________________________________________________
// recadrage pour cinema

int Set::Kicads ()
  {
  double Val, Delta[2][2] = { 0., 0., -2., +2. };
  int    Edx, Pdx, OlDelay, Place[2][2];

  for ( Pdx=0; Pdx<2; Pdx++ )		// Pdx=0   espace vu
    for ( Edx=0; Edx<2; Edx++ )		// Pdx=1   espace etendu
      {
      Place[Pdx][Edx] = Search
        ( Dynar+_Iou[0], _Pu[Edx][0] + Delta[Pdx][Edx] * _KiRatio,
          _TotCnt );
      if ( Place[Pdx][Edx] < 0 )   Place[Pdx][Edx] = 0;
      }

  if ( Place[1][0] == Place[1][1] )
    {
    _IsKino = 0;
    return 1;				// protection
    }

  // centre en Y = moyenne des magnitudes

  _PremAff = Place[1][0];
  _AffCnt  = Place[1][1] - Place[1][0] + 1;
  Val      = 0.;

  for ( Edx=Place[0][0]; Edx<=Place[0][1]; Edx++ )
    Val += Dynar[_Iou[1] + Edx];

  Val      /= double ( Place[0][1] - Place[0][0] + 1 );
  _Pu[0][1] = Val - 1.;			// 2 magnitudes en hauteur
  _Pu[1][1] = Val + 1.;
  _Ku       = 0;			// comme 1, sans le Search
  Pdx       = 0;
  OlDelay   = _Delay;
  Vigies ();
  Vijour ();

  if ( Place[0][1] == _TotCnt-1 )	// arret sur
    {					// derniere image
    _IsKino = 2;			// pour bouclage
    Pdx     = 1;
    }
  else if ( _IsKino == 2 )		// redemarrage en debut
    {					// de courbe
    _IsKino = 1;
    Pdx     = 1;
    }

  if ( !Pdx )
    _Delay  = 1 << _Speed;		// 8ms par defaut
  else					// 2s
    _Delay  = 0x100 << _Speed;

  if ( _Delay > 0x1000 )
    _Delay = 0x1000;			// 4s maxi

  if ( OlDelay != _Delay )
    {
    SuppTimer ();
    CreeTimer ( _Delay );
    }
  return 0;
  }
//______________________________________________________________________
// interactions et manipulations dans drawing area

void Set::Viracs ( int *Icla, int *Bou, float *Pos )
  {
  // point Po[rang 0 ou 1][X,Y]
  static  double Po[2][2];
  double  Delta, Val, *Pod;
  int     Idx, Edx, Pdx, Iap, IsSpeed;

  switch ( *Icla )			// selon type d' interaction
    {
    case 2:				// souris cliquee
      // boutons (1,2,3) donnent (5,6,7) en appui et (1,2,3) en lache
      if ( _IsKino   ||   ( *Bou & 3 ) == 2 )   return;
      if ( *Bou == 5 )			// bouton numero *Bou
        {
        _IsResize = 0;			// point de zoom au lacher
        return;
        }
      break;

    case 3:				// souris en mouvement
      if ( _IsKino   ||   _IsNoTrans )   return;
      break;

    case 5:				// caractere au clavier
      if ( _Chur >= 0x61   &&   _Chur <= 0x7A )
        _Chur -= 0x20;			// lettre minuscule ASCII
					// devient majuscule
      _IsResize = 0;
      IsSpeed   = 0;			// pas de chgt de vitesse
      Zo        = 1.25;			// reduction centree

      switch ( _Chur )			// selon touche clavier
        {
        //___________________________________________________________
        case 'Z':			// zoom_auto
          if ( _IsKino   &&   _Xb - _Xa < 2.6 )
            return;			// protection
          Zo = .8;			// zoom centre

        case 'R':			// reduit
          Pod = Dynar + _Iou[0];
          if ( _Chur == 'R'   &&   _IsKino   &&
               _Xb - _Xa > .24 * (Pod[_Limit[1]-1] - Pod[0]) )
            return;			// protection

          if ( _IsKino )   _KiRatio *= Zo;
          if ( _Iz )       Vider ();
          for ( Idx=0; Idx<2; Idx++ )
            {
            Val = ( _Wi[Idx][0] + _Wi[Idx][1] ) * .5;
            for ( Edx=0; Edx<2; Edx++ )
              _Wi[Idx][Edx] = ( _Wi[Idx][Edx] - Val ) * Zo + Val;
            }
          Vicads ();
          break;
        //___________________________________________________________
        case 'K':			// debut de cinema
          Val = ( _Xa + _Xb ) * .5;	// conserve centre en X
          if ( _KiRatio < 0. )   _KiRatio = 1.;
          _Pu[0][0] = Val - _KiRatio;
          _Pu[1][0] = Val + _KiRatio;
          _IsKino   = 1;		// 2 jours en largeur
          if ( Kicads () )   return;
          break;
        //___________________________________________________________
        case 'S':			// fin de cinema
          _IsKino = 0;
          _Delay  = -1;
          SuppTimer ();
          Vicads    ();
          break;
        //___________________________________________________________
        case '+':			// acceleration de cinema
          if ( _Vitesse < 5 )		// protection
            {
            _Vitesse++;
            _Avance += _Avance;
            IsSpeed  = 1;
            }
          break;
        //___________________________________________________________
        case '-':			// deceleration de cinema
          if ( _Vitesse > -5 )		// protection
            {
            _Vitesse--;
            _Avance *= .5;
            IsSpeed  = 1;
            }
          break;
        //___________________________________________________________
        case 'B':			// davantage de continuite
          if ( _Slice[_IsMaj] < Pont[0][_IsMaj] )
            _Slice[_IsMaj] *= 2.;
          _Ku = 3;
          ComputeImage ();
          break;
        //___________________________________________________________
        case 'H':			// moins de continuite
          if ( _Slice[_IsMaj] > Pont[1][_IsMaj] )
            _Slice[_IsMaj] *= .5;
          _Ku = 3;
          ComputeImage ();
          break;
        //___________________________________________________________
        case 'C':			// couleur [5, 32+5[
          _Col = (_Col - 4) % 32 + 5;
          _Ku  = 3;
          ComputeImage ();
        }

      if ( IsSpeed )
        {				// changement de vitesse
        if ( _IsKino )			//   du cinema
          {
          _Delay = 1 << _Speed;
          SuppTimer ();
          CreeTimer ( _Delay );
          }
        }
      return;

    //_______________________________________________________________
    case 6:				// evenement type timer
      if ( _IsKino == 1 )		// suite de cinema
        {
        _Pu[0][0] += _Avance;		// avance de 5% de largeur
        _Pu[1][0] += _Avance;		// d' image par seconde
        }
      else 				// rebouclage
        {				// _IsKino == 2
        _Pu[0][0] = Dynar[_Iou[0]];
        _Pu[1][0] = _Pu[0][0] + _Xb - _Xa;
        }				// largeur vraie >= 2.

      Kicads ();			// (pure translation)
      return;
    }
  //_________________________________________________________________
  Iap = _Iz;
  for ( Idx=0; Idx<2; Idx++ )           // position de souris Po
    Po[Iap][Idx] = ( _Wi[Idx][1] - _Wi[Idx][0] ) *
                   ( double (Pos[Idx]) - _Aje[Idx][0] )
		   / _VueTaille[Idx] + _Wi[Idx][0];

  //_________________________________________________________________
  if ( ( *Bou & 3 ) == 3 )              // dragging
    {
    // translation = bouton de droite de souris en dragging
    for ( Idx=0; Idx<2; Idx++ )
      {
      if ( _IsNoTrans )   _Pu[0][Idx] = Po[Iap][Idx];
      Delta = Po[Iap][Idx] - _Pu[0][Idx];
      for ( Pdx=0; Pdx<2; Pdx++ )   _Wi[Idx][Pdx] -= Delta;
      }

    if ( _Iz   &&   _IsNoTrans   &&   *Bou == 7 )
      Vider ();				// a l' appui
    _IsNoTrans = *Bou == 3;

    if ( _IsNoTrans )
      {					// au lacher
      if ( _Jat[7] )
        for ( Idx=0; Idx<2; Idx++ )
          _Wi[1][Idx] = _Aje[1][Idx] + _Aje[1][Idx] - _Wi[1][Idx];
      *Bou = 0;
      Vicads ();
      }
    else Vijour ();
    }
  //_________________________________________________________________
  else if ( _Iz )			// zoom manuel avec
    {					//   2 points Po
    if ( _Jat[7] )   Po[1][1] = _Wi[1][1] + _Wi[1][0] - Po[1][1];

    for ( Idx=0; Idx<2; Idx++ )
      {
      _Wi[Idx][0] = Po[0][Idx] < Po[1][Idx] ?
                    Po[0][Idx] : Po[1][Idx];
      _Wi[Idx][1] = Po[0][Idx] > Po[1][Idx] ?
                    Po[0][Idx] : Po[1][Idx];
      }
    Vider  ();				// detruit 1er point
    Vicads ();
    }
  //_________________________________________________________________
  else
    {					// 1er point de zoom
    Vipor  ( &Po[0][0] );
    if     ( _Jat[7] )   Po[0][1] = _Wi[1][1] + _Wi[1][0] - Po[0][1];
    Vinval ();
    }
  }
//______________________________________________________________________
